const MaxLoesungen =   1;               { Anzahl der angezeigten Lsungen }
      ungueltig    = 255;               { markiert ungltigen Eintrag }

type tKaestchen = (leer, bedroht, D, S);{ ein Kstchen des Schachbrettes }
     tBrett     = array[-1..10,-1..10] of tKaestchen;{ ein Schachbrett }
     tMaxFelder = array[1..100] of tBrett;{ speichert die entstehenden Lsungen }
     tFreiFeld  = array[1..25] of record{ Liste der freien Felder auf dem Brett }
                                     x,y: byte;
                                  end;

var MaxSpringer : byte;                 { max. gefundene Zahl von Springern }
    Varianten   : LongInt;              { Anzahl der Lsungen }
    StartBrett  : tBrett;               { Brett zum Start der Suche (leer) }
    MaxFelder   : tMaxFelder;           { speichert die entstehenden Lsungen }
    DamenPos    : array[1..3] of record { Positionen der Damen }
                                    x,y: byte;
                                 end;
    FreiAnzahl  : byte;                 { Anzahl der freien Felder }


procedure SucheSpringer(var Brett: tBrett; var FreiFeld: tFreiFeld; Springer: byte; Position: byte);
                                        { Sucht rekursiv mgliche Springer }
var NeuBrett      : tBrett;             { bearbeitetes Schachbrett }
    NeuFreiFeld   : tFreiFeld;          { bearbeitete Liste freier Felder }
    FreiLauf      : byte;               { durchluft freie Felder }
    Zeile, Spalte : byte;               { Laufvariablen }
begin
   if Position>FreiAnzahl then          { alle freien Felder abgesucht ? }
   begin                                { ja }
      if Springer>MaxSpringer then      { neue Hchstzahl an Springern gefunden ? }
      begin                             { ja }
         MaxSpringer:=Springer;         { Anzahl vermerken }
         Varianten:=0;                  { Variantenzhler wieder auf 0 setzen }
      end;

      if Springer=MaxSpringer then      { bei neuer Lsung oder neuer Hchstzahl }
      begin
         inc(Varianten);                { neue Lsung dazuzhlen }
         MaxFelder[Varianten]:=Brett;   { und diese Lsung abspeichern }
      end;
      exit;                             { diese Rekursion abbrechen }
   end;

   if FreiAnzahl-Position+Springer+1<MaxSpringer then
      exit;                             { keine neue Lsung mit dieser Position mglich ? wenn ja, Abbruch }

   Zeile:=FreiFeld[Position].x;         { Zeile auslesen }
   Spalte:=FreiFeld[Position].y;        { Spalte auslesen }

   if (Zeile<>ungueltig) and (Spalte<>ungueltig) then{ Eintrag als gltig markiert ? }
   begin                                { ja }
      NeuBrett:=Brett;                  { Brett bearbeiten }
      NeuBrett[Zeile,Spalte]:=S;        { Springer setzen }
      NeuBrett[Zeile-2,Spalte-1]:=bedroht;{ alle bedrohten Felder eintragen }
      NeuBrett[Zeile-1,Spalte-2]:=bedroht;
      NeuBrett[Zeile+1,Spalte+2]:=bedroht;
      NeuBrett[Zeile+2,Spalte+1]:=bedroht;
      NeuBrett[Zeile-2,Spalte+1]:=bedroht;
      NeuBrett[Zeile-1,Spalte+2]:=bedroht;
      NeuBrett[Zeile+1,Spalte-2]:=bedroht;
      NeuBrett[Zeile+2,Spalte-1]:=bedroht;

      NeuFreiFeld:=FreiFeld;            { Liste freier Felder bearbeiten }
      for FreiLauf:=Position to FreiAnzahl do{ jedes der in der Liste folgenden Felder knnten bedroht sein }
         if (NeuFreiFeld[FreiLauf].x<>ungueltig) and (NeuFreiFeld[FreiLauf].y<>ungueltig) then{ mu gltiger Eintrag sein }
            if NeuBrett[NeuFreiFeld[FreiLauf].x,NeuFreiFeld[FreiLauf].y]=bedroht then{ bedroht ? }
            begin                       { ja }
               NeuFreiFeld[FreiLauf].x:=ungueltig;{ als ungltig markieren }
               NeuFreiFeld[FreiLauf].y:=ungueltig;
            end;

      SucheSpringer(NeuBrett, NeuFreiFeld, Springer+1, Position+1);
                                        { nchsten Springer suchen, jetzt wurde einer gefunden }
   end;

   SucheSpringer(Brett, FreiFeld, Springer, Position+1);
                                        { nchsten Springer suchen, jetzt wurde keiner gefunden }
end;


procedure SucheDame(var Brett: tBrett; Damen: byte);
                                        { sucht Damen (bis zu 3) }
var Zeile,Spalte  : byte;               { Laufvariablen }
    x,y           : byte;               { Laufvariablen }
    NeuBrett      : tBrett;             { bearbeitetes Brett }
    StartFreiFeld : tFreiFeld;          { Startliste der freien Felder }
    BrettBreite   : byte;               { Raum, in dem neue Dame gesucht wird }
    Lauf          : byte;               { Laufvariable }
begin
   if Damen=1 then                      { um Rechenzeit zu sparen, wird erste Dame }
      BrettBreite:=4                    { nur im Bereich A1 bis D4 gesucht, da nach }
   else                                 { Spiegelung, Drehung usw. immer eine steht }
      BrettBreite:=8;                   { Normalmae des Bretts }

   for Zeile:=1 to BrettBreite do       { Brett zeilenweise absuchen }
      for Spalte:=1 to BrettBreite do   { jedes Kstchen untersuchen }
         if Brett[Zeile,Spalte]=leer then{ leer ? }
         begin                          { ja (sonst nchstes Kstchen) }
            NeuBrett:=Brett;            { Brett wird bearbeitet }

            DamenPos[Damen].x:=Zeile;   { Position der Dame vermerken }
            DamenPos[Damen].y:=Spalte;

            for Lauf:=1 to 8 do         { alle von der Dame bedrohten Kstchen markieren }
            begin
               NeuBrett[Zeile,Lauf]:=bedroht;{ die bedrohte Zeile }
               NeuBrett[Lauf,Spalte]:=bedroht;{ die bedrohte Spalte }

               if ((Zeile+Lauf<9) and (Spalte+Lauf<9)) then { im Brett ? }
                  NeuBrett[Zeile+Lauf,Spalte+Lauf]:=bedroht;{ Diagonale rechts unten }

               if ((Zeile+Lauf<9) and (Spalte-Lauf>0)) then { im Brett ? }
                  NeuBrett[Zeile+Lauf,Spalte-Lauf]:=bedroht;{ Diagonale links unten }

               if ((Zeile-Lauf>0) and (Spalte+Lauf<9)) then { im Brett ? }
                  NeuBrett[Zeile-Lauf,Spalte+Lauf]:=bedroht;{ Diagonale rechts oben }

               if ((Zeile-Lauf>0) and (Spalte-Lauf>0)) then { im Brett ? }
                  NeuBrett[Zeile-Lauf,Spalte-Lauf]:=bedroht;{ Diagonale links oben }
            end;
            NeuBrett[Zeile,Spalte]:=D;  { Dame auch setzen }

            if Damen<3 then             { noch nicht der 3.Durchlauf ? }
               SucheDame(NeuBrett,Damen+1){ ja, suche nchste Dame }
            else                        { nein, fange mit Suche nach Springern an }
            begin
               for Lauf:=1 to 3 do      { durchlaufe alle Damen }
               begin
                  x:=DamenPos[Lauf].x;  { hole ihre jeweilige Position }
                  y:=DamenPos[Lauf].y;
                  if (NeuBrett[x-2,y-1]<>D) then{ alle Felder, auf denen keine }
                     NeuBrett[x-2,y-1]:=bedroht;{ Springer stehen drfen, da sie }
                  if (NeuBrett[x-1,y-2]<>D) then{ sonst die Dame bedrohen, markieren }
                     NeuBrett[x-1,y-2]:=bedroht;
                  if (NeuBrett[x+1,y+2]<>D) then
                     NeuBrett[x+1,y+2]:=bedroht;
                  if (NeuBrett[x+2,y+1]<>D) then
                     NeuBrett[x+2,y+1]:=bedroht;
                  if (NeuBrett[x-2,y+1]<>D) then
                     NeuBrett[x-2,y+1]:=bedroht;
                  if (NeuBrett[x-1,y+2]<>D) then
                     NeuBrett[x-1,y+2]:=bedroht;
                  if (NeuBrett[x+1,y-2]<>D) then
                     NeuBrett[x+1,y-2]:=bedroht;
                  if (NeuBrett[x+2,y-1]<>D) then
                     NeuBrett[x+2,y-1]:=bedroht;
               end;

               FreiAnzahl:=0;           { Liste der freien Kstchen aufbauen, beim Anfang beginnen }
               for x:=1 to 8 do         { jede Zeile durchlaufen }
                  for y:=1 to 8 do      { jede Spalte durchlaufen }
                     if NeuBrett[x,y]=leer then{ ist dieses Kstchen frei ? }
                     begin              { ja }
                        inc(FreiAnzahl);{ Listenzeiger weiterrcken }
                        StartFreiFeld[FreiAnzahl].x:=x;{ trage Koordinaten in die Liste ein }
                        StartFreiFeld[FreiAnzahl].y:=y;
                     end;

               SucheSpringer(NeuBrett,StartFreiFeld,0,1);{ Springersuche beginnen }
            end;
         end;
end;


procedure FiltereLoesungen;             { Lsungen, die sich durch Spiegelung und Drehung ergeben ausfiltern }
var TempMaxFelder  : tMaxFelder;        { neue Liste aller nichtidentischen Lsungen }
    Loesungen      : byte;              { Laufvariable }
    Vergleich      : byte;              { Laufvariable }
    x,y            : byte;              { Laufvariablen }
    Vorhanden      : boolean;           { ist diese Lsung doppelt ? }
    WahreVarianten : byte;              { Anzahl "echter" Lsungen }
begin
   TempMaxFelder[1]:=MaxFelder[1];      { erste Lsung kann bernommen werden }
   WahreVarianten:=1;                   { als gefunden markieren }

   for Loesungen:=2 to Varianten do     { alle anderen Lsungen untersuchen }
   begin
      for Vergleich:=1 to WahreVarianten do{ mit allen vorher untersuchten vergleichen }
      begin
         Vorhanden:=true;               { von Doppelheit ausgehen }
         for x:=1 to 8 do               { Feld komplett untersuchen }
            for y:=1 to 8 do
               if MaxFelder[Loesungen][x,y]<>TempMaxFelder[Vergleich][x,y] then
                  Vorhanden:=false;     { bei Unterschied neue Lsung }
         if Vorhanden then break;       { falls neue Lsung: Abbruch der Untersuchung }

         Vorhanden:=true;               { von Doppelheit ausgehen }
         for x:=1 to 8 do               { Feld komplett untersuchen }
            for y:=1 to 8 do
               if MaxFelder[Loesungen][x,y]<>TempMaxFelder[Vergleich][y,x] then
                  Vorhanden:=false;     { bei Unterschied neue Lsung }
         if Vorhanden then break;       { falls neue Lsung: Abbruch der Untersuchung }

         Vorhanden:=true;               { von Doppelheit ausgehen }
         for x:=1 to 8 do               { Feld komplett untersuchen }
            for y:=1 to 8 do
               if MaxFelder[Loesungen][x,y]<>TempMaxFelder[Vergleich][9-x,y] then
                  Vorhanden:=false;     { bei Unterschied neue Lsung }
         if Vorhanden then break;       { falls neue Lsung: Abbruch der Untersuchung }

         Vorhanden:=true;               { von Doppelheit ausgehen }
         for x:=1 to 8 do               { Feld komplett untersuchen }
            for y:=1 to 8 do
               if MaxFelder[Loesungen][x,y]<>TempMaxFelder[Vergleich][x,9-y] then
                  Vorhanden:=false;     { bei Unterschied neue Lsung }
         if Vorhanden then break;       { falls neue Lsung: Abbruch der Untersuchung }

         Vorhanden:=true;               { von Doppelheit ausgehen }
         for x:=1 to 8 do               { Feld komplett untersuchen }
            for y:=1 to 8 do
               if MaxFelder[Loesungen][x,y]<>TempMaxFelder[Vergleich][9-x,9-y] then
                  Vorhanden:=false;     { bei Unterschied neue Lsung }
         if Vorhanden then break;       { falls neue Lsung: Abbruch der Untersuchung }

         Vorhanden:=true;               { von Doppelheit ausgehen }
         for x:=1 to 8 do               { Feld komplett untersuchen }
            for y:=1 to 8 do
               if MaxFelder[Loesungen][x,y]<>TempMaxFelder[Vergleich][9-y,x] then
                  Vorhanden:=false;     { bei Unterschied neue Lsung }
         if Vorhanden then break;       { falls neue Lsung: Abbruch der Untersuchung }

         Vorhanden:=true;               { von Doppelheit ausgehen }
         for x:=1 to 8 do               { Feld komplett untersuchen }
            for y:=1 to 8 do
               if MaxFelder[Loesungen][x,y]<>TempMaxFelder[Vergleich][y,9-x] then
                  Vorhanden:=false;     { bei Unterschied neue Lsung }
         if Vorhanden then break;       { falls neue Lsung: Abbruch der Untersuchung }

         Vorhanden:=true;               { von Doppelheit ausgehen }
         for x:=1 to 8 do               { Feld komplett untersuchen }
            for y:=1 to 8 do
               if MaxFelder[Loesungen][x,y]<>TempMaxFelder[Vergleich][9-y,9-x] then
                  Vorhanden:=false;     { bei Unterschied neue Lsung }
         if Vorhanden then break;       { falls neue Lsung: Abbruch der Untersuchung }
      end;

      if not Vorhanden then             { neue Lsung gefunden ? }
      begin
         inc(WahreVarianten);           { Anzahl der Varianten erhhen }
         TempMaxFelder[WahreVarianten]:=MaxFelder[Loesungen];
                                        { die Lsung eintragen }
      end;
   end;

   MaxFelder:=TempMaxFelder;            { alle nichtidentischen Lsungen sichern }
   Varianten:=WahreVarianten;           { Anzahl der Varianten korrigieren }
end;


var Lauf,x,y : byte;                    { Laufvariablen }
begin
   MaxSpringer:=0;                      { erstmal von Minimalfall kein Springer pat aufs Feld ausgehen }
   Varianten:=0;                        { keine Varianten davon gefunden }
   fillchar(StartBrett,sizeof(StartBrett),leer);
                                        { Feld zum Start initialisieren }
   SucheDame(StartBrett,1);             { Suche beginnen }
   FiltereLoesungen;                    { alle doppelten Lsungen herausfiltern }

   for Lauf:=1 to MaxLoesungen do       { gewnschte Anzahl von Lsungen ausgeben }
   begin
      writeln('Variante ',Lauf,':');    { Nummer der Lsung anzeigen }
      writeln('   A B C D E F G H');    { Brett beschriften }
      for x:=1 to 8 do                  { jede Zeile durchlaufen }
      begin
         write(x:2,' ');                { Brett beschriften }
         for y:=1 to 8 do               { jede Spalte durchlaufen }
            case MaxFelder[Lauf][x,y] of{ jeden Kstchentyp unterschiedlich anzeigen }
               bedroht : write('. ');   { Feld ist bedroht }
               S       : write('S ');   { Springer steht auf diesem Feld }
               D       : write('D ');   { Dame steht auf diesem Feld }
            end;
         writeln;                       { eine Zeile voll, Zeilenumbruch }
      end;
      writeln('   A B C D E F G H');    { Brett beschriften }
   end;

   writeln(MaxSpringer,' Springer passen in ',Varianten,' Varianten auf das Spielbrett.');
                                        { Antwortsatz ausgeben ber Programmergebnis }
end.